/* Copyright 2010 ESRI
* 
* All rights reserved under the copyright laws of the United States
* and applicable international laws, treaties, and conventions.
* 
* You may freely redistribute and use this sample code, with or
* without modification, provided you include the original copyright
* notice and use restrictions.
* 
* See the use restrictions at http://help.arcgis.com/en/sdk/10.0/usageRestrictions.htm
* 
*/
package com.esri.arcgis.sample.simplerouting;

import com.esri.adf.web.data.tasks.TaskParamDescriptor;
import com.esri.adf.web.data.tasks.TaskParamDescriptorModel;
import com.esri.adf.web.util.XMLUtil;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

final class RoutingTaskParamDescriptor implements TaskParamDescriptorModel {
  String fieldName;
  String fieldValue;
  String paramName;

  RoutingTaskParamDescriptor(String fieldName, String paramName) {
    this.fieldName = fieldName;
    this.paramName = paramName;
  }

  public String getName() {
    return paramName;
  }

  public String getDisplayName() {
    return paramName;
  }

  public String getRendererType() {
    return TaskParamDescriptor.TEXT_RENDERER_TYPE;
  }

  public Object setParamValue(Object task, String strVal) {
    fieldValue = strVal;
    return fieldValue;
  }

  public Object getParamValue(Object task) {
    return fieldValue;
  }

  public Element generateXML(Object task) {
    Document doc = XMLUtil.newDocument();
    // task-param
    Element elem = XMLUtil.createElement(doc, "task-param", null, null);
    // type attribute
    elem.setAttribute("type", TaskParamDescriptor.TEXT_RENDERER_TYPE);
    // name attribute
    elem.setAttribute("name", paramName);
    // visible attribute
    elem.setAttribute("visible", "true");
    // disabled attribute
    elem.setAttribute("disabled", "false");
    // value
    XMLUtil.createElement(doc, "value", fieldValue, elem);
    // display-name
    XMLUtil.createElement(doc, "display-name", paramName, elem);
    return elem;
  }
}
